/**********************************************************
Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
***********************************************************/

#include <mega8.h> 
#define RS PORTC.4     //0- , 1- 
#define E PORTC.5      //    
#define DB7 PORTC.3    //  4-  
#define DB6 PORTC.2
#define DB5 PORTC.1
#define DB4 PORTC.0
#define time 80        //  
#pragma rl-            

//------------  -----------------------
void delay(unsigned int a)
{unsigned int cnt;
 for (cnt=a; cnt>0; cnt--);
}    
//------------------   --------------------
void lcd(unsigned char d)
 {E=1;   
  DB7=(d&0x80)>>7;    //  
  DB6=(d&0x40)>>6;
  DB5=(d&0x20)>>5;
  DB4=(d&0x10)>>4;
  delay(time);        //
  E=0;                //
  delay(time);        //
  E=1;                //enable = 1
  DB7=(d&0x08)>>3;    //  
  DB6=(d&0x04)>>2; 
  DB5=(d&0x02)>>1; 
  DB4=(d&0x01); 
  delay(time);        //    
  E=0;                //
  delay(5*time);      //       
 }   
//------------    -------------------
void lcd_com(unsigned char c)
{RS=0;                       //  
 lcd(c);                     //
}
 //----------    ---------------------
void lcd_putchar(unsigned char d)
 {RS=1;                       //  
  lcd(d);                     //
 }     
//-------------  ---------------------------
void lcd_clear(void)
{lcd_com(0x01); delay(time*1000);// 
}
//-----------  -----------------------
void lcd_init(void)
{delay(time*100);                // 
 lcd_com(0x33); delay(time*500); //
 lcd_com(0x32); lcd_com(0x28);   //4 , 2  (. Datasheet-s)
 lcd_com(0x08);                  // 
 lcd_clear();                    // 
 lcd_com(0x06);                  //  
 lcd_com(0x0C);                  //  
 delay(time*5);                  //       
}         
//----------    ---------------------
void lcd_puts(unsigned char *str)
{unsigned char i;
 while (i=*str++) lcd_putchar(i);
}
//--------      FLASH--------------
void lcd_putsf(char flash *str)
{unsigned char i;
while (i=*str++) lcd_putchar(i);
}
//--------     --------------
void lcd_gotoxy(unsigned char x, unsigned char y)
{
 lcd_com((0x80+y*64)+x); // .  080 - . . 
}
//------- ------------------------------------
void main(void)
{unsigned char i;
//   C
// Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTC=0x00;
DDRC=0x7F;

lcd_init();
lcd_gotoxy(1,0);
lcd_putsf("  162");
lcd_gotoxy(0,1);
lcd_putsf(" = ");
while (1) 
{lcd_gotoxy(9,1);
 lcd_putchar(i);
 delay(60000);
 delay(60000);
 i++;
}
}
